<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLCCOtherFee ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfLCCOtherFee extends AbstractStructArrayBase
{
    /**
     * The LCCOtherFee
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \dgsoft\StructType\DgLCCOtherFee[]
     */
    public $LCCOtherFee;
    /**
     * Constructor method for ArrayOfLCCOtherFee
     * @uses DgArrayOfLCCOtherFee::setLCCOtherFee()
     * @param \dgsoft\StructType\DgLCCOtherFee[] $lCCOtherFee
     */
    public function __construct(array $lCCOtherFee = array())
    {
        $this
            ->setLCCOtherFee($lCCOtherFee);
    }
    /**
     * Get LCCOtherFee value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \dgsoft\StructType\DgLCCOtherFee[]|null
     */
    public function getLCCOtherFee()
    {
        return isset($this->LCCOtherFee) ? $this->LCCOtherFee : null;
    }
    /**
     * Set LCCOtherFee value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgLCCOtherFee[] $lCCOtherFee
     * @return \dgsoft\ArrayType\DgArrayOfLCCOtherFee
     */
    public function setLCCOtherFee(array $lCCOtherFee = array())
    {
        foreach ($lCCOtherFee as $arrayOfLCCOtherFeeLCCOtherFeeItem) {
            // validation for constraint: itemType
            if (!$arrayOfLCCOtherFeeLCCOtherFeeItem instanceof \dgsoft\StructType\DgLCCOtherFee) {
                throw new \InvalidArgumentException(sprintf('The LCCOtherFee property can only contain items of \dgsoft\StructType\DgLCCOtherFee, "%s" given', is_object($arrayOfLCCOtherFeeLCCOtherFeeItem) ? get_class($arrayOfLCCOtherFeeLCCOtherFeeItem) : gettype($arrayOfLCCOtherFeeLCCOtherFeeItem)), __LINE__);
            }
        }
        if (is_null($lCCOtherFee) || (is_array($lCCOtherFee) && empty($lCCOtherFee))) {
            unset($this->LCCOtherFee);
        } else {
            $this->LCCOtherFee = $lCCOtherFee;
        }
        return $this;
    }
    /**
     * Add item to LCCOtherFee value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgLCCOtherFee $item
     * @return \dgsoft\ArrayType\DgArrayOfLCCOtherFee
     */
    public function addToLCCOtherFee(\dgsoft\StructType\DgLCCOtherFee $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgLCCOtherFee) {
            throw new \InvalidArgumentException(sprintf('The LCCOtherFee property can only contain items of \dgsoft\StructType\DgLCCOtherFee, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->LCCOtherFee[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgLCCOtherFee|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgLCCOtherFee|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgLCCOtherFee|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgLCCOtherFee|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgLCCOtherFee|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string LCCOtherFee
     */
    public function getAttributeName()
    {
        return 'LCCOtherFee';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfLCCOtherFee
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
